package jesse.keeblarcraft.GuiMgr;

import jesse.keeblarcraft.CustomBlocks.BlockEntities.FactionBlockEntity;
import net.minecraft.block.entity.BlockEntity;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.entity.player.PlayerInventory;
import net.minecraft.inventory.Inventory;
import net.minecraft.item.ItemStack;
import net.minecraft.network.PacketByteBuf;
import net.minecraft.screen.ArrayPropertyDelegate;
import net.minecraft.screen.PropertyDelegate;
import net.minecraft.screen.ScreenHandler;
import net.minecraft.screen.slot.Slot;

public class FactionBlockScreenHandler extends ScreenHandler {
    private final Inventory inventory;
    private final PropertyDelegate propertyDelegate;
    public final FactionBlockEntity blockEntity;

    public FactionBlockScreenHandler(int syncId, PlayerInventory inventory, PacketByteBuf buf) {
        this(syncId, inventory, inventory.player.getWorld().getBlockEntity(buf.readBlockPos()), new ArrayPropertyDelegate(4));
    }

    public FactionBlockScreenHandler(int syncId, PlayerInventory playerInventory, BlockEntity blockEntity, PropertyDelegate arrayPropertyDelegate) {
        super(ScreenHandlerRegistration.FACTION_BLOCK_SCREEN_HANDLER, syncId);
        checkSize((Inventory) blockEntity, 4);
        this.inventory = (Inventory) blockEntity;
        inventory.onOpen(playerInventory.player);
        this.propertyDelegate = arrayPropertyDelegate;
        this.blockEntity = (FactionBlockEntity) blockEntity;

        // TODO: These positions need to be redrawn with an actual GUI
        this.addSlot(new Slot(inventory, 0, 60, 11));
        this.addSlot(new Slot(inventory, 1, 70, 11));
        this.addSlot(new Slot(inventory, 2, 80, 11));
        this.addSlot(new Slot(inventory, 3, 90, 11));

        // Need to reference Kaupendim tutorial again; but we could theoretically just add the player inventory
        // right here so that they can drag items in and whatnot (I assume). I am unsure if I am taking that
        // direction with this block RIGHT NOW - so for now I am NOT doing that

        // Remainder stuff
        addProperties(arrayPropertyDelegate);
    }

    // This is just for SHIFT+CLICK moving
    @Override
    public ItemStack quickMove(PlayerEntity player, int invSlot) {
        ItemStack newStack = ItemStack.EMPTY;
        Slot slot = this.slots.get(invSlot);
        if (slot != null && slot.hasStack()) {
            ItemStack originalStack = slot.getStack();
            newStack = originalStack.copy();

            // TODO: This is from the YT video and it looks atrocious. Refactor this later
            if ( (invSlot < this.inventory.size() && !this.insertItem(originalStack, this.inventory.size(), this.slots.size(), true) ) ||
                (!this.insertItem(originalStack, 0, this.inventory.size(), false))) {
                return ItemStack.EMPTY;
            }

            if (originalStack.isEmpty()) {
                slot.setStack(ItemStack.EMPTY);
            } else {
                slot.markDirty();;
            }
        }

        return newStack;
    }

    @Override
    public boolean canUse(PlayerEntity player) {
        return this.inventory.canPlayerUse(player);
    }
}
